/* defines the types for several internal data structures */

typedef struct
	{	char *start,*end;
		int slot;
	}
	blocktyp;
extern blocktyp block;

typedef struct { char *line; int slot; } markertyp;
#define MAXMARKER 6
/* two more than needed! */
extern markertyp marker[MAXMARKER];

#define RESERVE (params.reserve)
#define FRESERVE (params.freserve)

#define MAXSLOTS 16

typedef struct 
	{	char *start,*end,*fend,*topl;
		struct 
			{	int used,
				updated,
				info,
				readonly,
				full,
				indent,
				insert,
				blanks,
				wordwrap;
			} flags;
		int x,y,w,h,xl,wl,hl,left,tabs,linelength,mode;
		int xold,yold,wold,hold;
		int whandle,elements;
		char name[256];
		char info[128];
		struct
			{	int x,y;
				char *line,*adr;
			} cursor;
		struct
			{	int open;
				char *start,*end;
			} gap;
	} filetyp;
extern filetyp files[MAXSLOTS];
extern char *ramstart,*ramend,*ramfree;

typedef struct
	{	char *undo, *start, *end;
		int slot;
	}
	undotyp;
extern undotyp undo;

typedef struct { char header[16];
	int full,tabsize,linelength,indent,blanks,dup,arguments,config
		,insert,wordwrap,paral,scrollbar; 
	long reserve,freserve,memfree; } paramtyp;
extern paramtyp params;

extern int cursoron;

